/*
 * (C) Copyright 2011 Samsung Electronics Co. Ltd
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 */

#include <common.h>
#include <asm/arch/bq24160.h>

void Delay(void)
{
	unsigned long i;
	for(i=0;i<DELAY;i++);
}

void IIC0_SCLH_SDAH(void)
{
	IIC0_ESCL_Hi;
	IIC0_ESDA_Hi;
	Delay();
}

void IIC0_SCLH_SDAL(void)
{
	IIC0_ESCL_Hi;
	IIC0_ESDA_Lo;
	Delay();
}

void IIC0_SCLL_SDAH(void)
{
	IIC0_ESCL_Lo;
	IIC0_ESDA_Hi;
	Delay();
}

void IIC0_SCLL_SDAL(void)
{
	IIC0_ESCL_Lo;
	IIC0_ESDA_Lo;
	Delay();
}

void IIC1_SCLH_SDAH(void)
{
	IIC1_ESCL_Hi;
	IIC1_ESDA_Hi;
	Delay();
}

void IIC1_SCLH_SDAL(void)
{
	IIC1_ESCL_Hi;
	IIC1_ESDA_Lo;
	Delay();
}

void IIC1_SCLL_SDAH(void)
{
	IIC1_ESCL_Lo;
	IIC1_ESDA_Hi;
	Delay();
}

void IIC1_SCLL_SDAL(void)
{
	IIC1_ESCL_Lo;
	IIC1_ESDA_Lo;
	Delay();
}

void IIC3_SCLH_SDAH(void)
{
	IIC3_ESCL_Hi;
	IIC3_ESDA_Hi;
	Delay();
}

void IIC3_SCLH_SDAL(void)
{
	IIC3_ESCL_Hi;
	IIC3_ESDA_Lo;
	Delay();
}

void IIC3_SCLL_SDAH(void)
{
	IIC3_ESCL_Lo;
	IIC3_ESDA_Hi;
	Delay();
}

void IIC3_SCLL_SDAL(void)
{
	IIC3_ESCL_Lo;
	IIC3_ESDA_Lo;
	Delay();
}

void IIC0_ELow(void)
{
	IIC0_SCLL_SDAL();
	IIC0_SCLH_SDAL();
	IIC0_SCLH_SDAL();
	IIC0_SCLL_SDAL();
}

void IIC0_EHigh(void)
{
	IIC0_SCLL_SDAH();
	IIC0_SCLH_SDAH();
	IIC0_SCLH_SDAH();
	IIC0_SCLL_SDAH();
}

void IIC1_ELow(void)
{
	IIC1_SCLL_SDAL();
	IIC1_SCLH_SDAL();
	IIC1_SCLH_SDAL();
	IIC1_SCLL_SDAL();
}

void IIC1_EHigh(void)
{
	IIC1_SCLL_SDAH();
	IIC1_SCLH_SDAH();
	IIC1_SCLH_SDAH();
	IIC1_SCLL_SDAH();
}

void IIC3_ELow(void)
{
	IIC3_SCLL_SDAL();
	IIC3_SCLH_SDAL();
	IIC3_SCLH_SDAL();
	IIC3_SCLL_SDAL();
}

void IIC3_EHigh(void)
{
	IIC3_SCLL_SDAH();
	IIC3_SCLH_SDAH();
	IIC3_SCLH_SDAH();
	IIC3_SCLL_SDAH();
}

void IIC0_EStart(void)
{
	IIC0_SCLH_SDAH();
	IIC0_SCLH_SDAL();
	Delay();
	IIC0_SCLL_SDAL();
}

void IIC0_EEnd(void)
{
	IIC0_SCLL_SDAL();
	IIC0_SCLH_SDAL();
	Delay();
	IIC0_SCLH_SDAH();
}

void IIC0_EAck_write(void)
{
	unsigned long ack;

	IIC0_ESDA_INP;			// Function <- Input

	IIC0_ESCL_Lo;
	Delay();
	IIC0_ESCL_Hi;
	Delay();
	ack = GPD1DAT;
	IIC0_ESCL_Hi;
	Delay();
	IIC0_ESCL_Hi;
	Delay();

	IIC0_ESDA_OUTP;			// Function <- Output (SDA)

	ack = (ack>>0)&0x1;
//	while(ack!=0);

	IIC0_SCLL_SDAL();
}

void IIC0_EAck_read(void)
{
	IIC0_ESDA_OUTP;			// Function <- Output

	IIC0_ESCL_Lo;
	IIC0_ESCL_Lo;
	//IIC0_ESDA_Lo;
	IIC0_ESDA_Hi;
	IIC0_ESCL_Hi;
	IIC0_ESCL_Hi;

	IIC0_ESDA_INP;			// Function <- Input (SDA)

	IIC0_SCLL_SDAL();
}

void IIC1_EStart(void)
{
	IIC1_SCLH_SDAH();
	IIC1_SCLH_SDAL();
	Delay();
	IIC1_SCLL_SDAL();
}

void IIC1_EAck_write(void)
{
    unsigned long ack;

    IIC1_ESDA_INP;                  // Function <- Input

    IIC1_ESCL_Lo;
    Delay();
    IIC1_ESCL_Hi;
    Delay();
    ack = GPD1DAT;
    IIC1_ESCL_Hi;
    Delay();
    IIC1_ESCL_Hi;
    Delay();

    IIC1_ESDA_OUTP;                 // Function <- Output (SDA)

    ack = (ack>>2)&0x1;
    //      while(ack!=0);

    IIC1_SCLL_SDAL();
}

void IIC1_EAck_read(void)
{
    IIC1_ESDA_OUTP;                 // Function <- Output

    IIC1_ESCL_Lo;
    IIC1_ESCL_Lo;
    //IIC1_ESDA_Lo;
    IIC1_ESDA_Hi;
    IIC1_ESCL_Hi;
    IIC1_ESCL_Hi;

    IIC1_ESDA_INP;                  // Function <- Input (SDA)

    IIC1_SCLL_SDAL();
}

void IIC1_EEnd(void)
{
	IIC1_SCLL_SDAL();
	IIC1_SCLH_SDAL();
	Delay();
	IIC1_SCLH_SDAH();
}

void IIC1_EAck(void)
{
	unsigned long ack;

	IIC1_ESDA_INP;			// Function <- Input

	IIC1_ESCL_Lo;
	Delay();
	IIC1_ESCL_Hi;
	Delay();
	ack = GPD1DAT;
	IIC1_ESCL_Hi;
	Delay();
	IIC1_ESCL_Hi;
	Delay();

	IIC1_ESDA_OUTP;			// Function <- Output (SDA)

	ack = (ack>>2)&0x1;
//	while(ack!=0);

	IIC1_SCLL_SDAL();
}

void IIC3_EStart(void)
{
	IIC3_SCLH_SDAH();
	IIC3_SCLH_SDAL();
	Delay();
	IIC3_SCLL_SDAL();
}

void IIC3_EEnd(void)
{
	IIC3_SCLL_SDAL();
	IIC3_SCLH_SDAL();
	Delay();
	IIC3_SCLH_SDAH();
}

void IIC3_EAck(void)
{
	unsigned long ack;

	IIC3_ESDA_INP;			// Function <- Input

	IIC3_ESCL_Lo;
	Delay();
	IIC3_ESCL_Hi;
	Delay();
	ack = GPA1DAT;
	IIC3_ESCL_Hi;
	Delay();
	IIC3_ESCL_Hi;
	Delay();

	IIC3_ESDA_OUTP;			// Function <- Output (SDA)

	ack = (ack>>2)&0x1;
//	while(ack!=0);

	IIC3_SCLL_SDAL();
}


void IIC0_ESetport(void)
{
	GPD1PUD &= ~(0xf<<0);	// Pull Up/Down Disable	SCL, SDA

	IIC0_ESCL_Hi;
	IIC0_ESDA_Hi;

	IIC0_ESCL_OUTP;		// Function <- Output (SCL)
	IIC0_ESDA_OUTP;		// Function <- Output (SDA)

	Delay();
}

void IIC1_ESetport(void)
{
	GPD1PUD &= ~(0xf<<4);	// Pull Up/Down Disable	SCL, SDA

	IIC1_ESCL_Hi;
	IIC1_ESDA_Hi;

	IIC1_ESCL_OUTP;		// Function <- Output (SCL)
	IIC1_ESDA_OUTP;		// Function <- Output (SDA)

	Delay();
}

void IIC3_ESetport(void)
{
	GPA1PUD &= ~(0xf<<4);	// Pull Up/Down Disable	SCL, SDA

	IIC3_ESCL_Hi;
	IIC3_ESDA_Hi;

	IIC3_ESCL_OUTP;		// Function <- Output (SCL)
	IIC3_ESDA_OUTP;		// Function <- Output (SDA)

	Delay();
}

void IIC0_EWrite (unsigned char ChipId, unsigned char IicAddr, unsigned char IicData)
{
	unsigned long i;

	IIC0_EStart();

////////////////// write chip id //////////////////
	for(i = 7; i>0; i--)
	{
		if((ChipId >> i) & 0x0001)
			IIC0_EHigh();
		else
			IIC0_ELow();
	}

	IIC0_ELow();	// write

	IIC0_EAck_write();	// ACK

////////////////// write reg. addr. //////////////////
	for(i = 8; i>0; i--)
	{
		if((IicAddr >> (i-1)) & 0x0001)
			IIC0_EHigh();
		else
			IIC0_ELow();
	}

	IIC0_EAck_write();	// ACK

////////////////// write reg. data. //////////////////
	for(i = 8; i>0; i--)
	{
		if((IicData >> (i-1)) & 0x0001)
			IIC0_EHigh();
		else
			IIC0_ELow();
	}

	IIC0_EAck_write();	// ACK

	IIC0_EEnd();
}

void IIC0_ERead (unsigned char ChipId, unsigned char IicAddr, unsigned char *IicData)
{
	unsigned long i, reg;
	unsigned char data = 0;

	IIC0_EStart();

////////////////// write chip id //////////////////
	for(i = 7; i>0; i--)
	{
		if((ChipId >> i) & 0x0001)
			IIC0_EHigh();
		else
			IIC0_ELow();
	}

	IIC0_ELow();	// write

	IIC0_EAck_write();	// ACK

////////////////// write reg. addr. //////////////////
	for(i = 8; i>0; i--)
	{
		if((IicAddr >> (i-1)) & 0x0001)
			IIC0_EHigh();
		else
			IIC0_ELow();
	}

	IIC0_EAck_write();	// ACK

	IIC0_EStart();

////////////////// write chip id //////////////////
	for(i = 7; i>0; i--)
	{
		if((ChipId >> i) & 0x0001)
			IIC0_EHigh();
		else
			IIC0_ELow();
	}

	IIC0_EHigh();	// read

	IIC0_EAck_write();	// ACK

////////////////// read reg. data. //////////////////
	IIC0_ESDA_INP;

	IIC0_ESCL_Lo;
	IIC0_ESCL_Lo;
	Delay();

	for(i = 8; i>0; i--)
	{
		IIC0_ESCL_Lo;
		IIC0_ESCL_Lo;
		Delay();
		IIC0_ESCL_Hi;
		IIC0_ESCL_Hi;
		Delay();
		reg = GPD1DAT;
		IIC0_ESCL_Hi;
		IIC0_ESCL_Hi;
		Delay();
		IIC0_ESCL_Lo;
		IIC0_ESCL_Lo;
		Delay();

		reg = (reg >> 0) & 0x1;
		data |= reg << (i-1);
	}

	IIC0_EAck_read();	// ACK
	IIC0_ESDA_OUTP;

	IIC0_EEnd();

	*IicData = data;
}

void IIC1_ERead (unsigned char ChipId, unsigned char IicAddr, unsigned char *IicData)
{
    unsigned long i, reg;
    unsigned char data = 0;

    IIC1_EStart();

    ////////////////// write chip id //////////////////
    for(i = 7; i>0; i--)
    {
        if((ChipId >> i) & 0x0001)
            IIC1_EHigh();
        else
            IIC1_ELow();
    }

    IIC1_ELow();    // write

    IIC1_EAck_write();      // ACK

    ////////////////// write reg. addr. //////////////////
    for(i = 8; i>0; i--)
    {
        if((IicAddr >> (i-1)) & 0x0001)
            IIC1_EHigh();
        else
            IIC1_ELow();
    }

    IIC1_EAck_write();      // ACK

    IIC1_EStart();

    ////////////////// write chip id //////////////////
    for(i = 7; i>0; i--)
    {
        if((ChipId >> i) & 0x0001)
            IIC1_EHigh();
        else
            IIC1_ELow();
    }

    IIC1_EHigh();   // read

    IIC1_EAck_write();      // ACK

    ////////////////// read reg. data. //////////////////
    IIC1_ESDA_INP;

    IIC1_ESCL_Lo;
    IIC1_ESCL_Lo;
    Delay();

    for(i = 8; i>0; i--)
    {
        IIC1_ESCL_Lo;
        IIC1_ESCL_Lo;
        Delay();
        IIC1_ESCL_Hi;
        IIC1_ESCL_Hi;
        Delay();
        reg = GPD1DAT;
        IIC1_ESCL_Hi;
        IIC1_ESCL_Hi;
        Delay();
        IIC1_ESCL_Lo;
        IIC1_ESCL_Lo;
        Delay();

        reg = (reg >> 2) & 0x1;
        data |= reg << (i-1);
    }

    IIC1_EAck_read();       // ACK
    IIC1_ESDA_OUTP;

    IIC1_EEnd();

    *IicData = data;
}

void IIC1_EWrite (unsigned char ChipId, unsigned char IicAddr, unsigned char IicData)
{
	unsigned long i;

	IIC1_EStart();

////////////////// write chip id //////////////////
	for(i = 7; i>0; i--)
	{
		if((ChipId >> i) & 0x0001)
			IIC1_EHigh();
		else
			IIC1_ELow();
	}

	IIC1_ELow();	// write 'W'

	IIC1_EAck();	// ACK

////////////////// write reg. addr. //////////////////
	for(i = 8; i>0; i--)
	{
		if((IicAddr >> (i-1)) & 0x0001)
			IIC1_EHigh();
		else
			IIC1_ELow();
	}

	IIC1_EAck();	// ACK

////////////////// write reg. data. //////////////////
	for(i = 8; i>0; i--)
	{
		if((IicData >> (i-1)) & 0x0001)
			IIC1_EHigh();
		else
			IIC1_ELow();
	}

	IIC1_EAck();	// ACK

	IIC1_EEnd();
}

void IIC3_EWrite (unsigned char ChipId, unsigned char IicAddr, unsigned char IicData)
{
	unsigned long i;

	IIC3_EStart();

////////////////// write chip id //////////////////
	for(i = 7; i>0; i--)
	{
		if((ChipId >> i) & 0x0001)
			IIC3_EHigh();
		else
			IIC3_ELow();
	}

	IIC3_ELow();	// write 'W'

	IIC3_EAck();	// ACK

////////////////// write reg. addr. //////////////////
	for(i = 8; i>0; i--)
	{
		if((IicAddr >> (i-1)) & 0x0001)
			IIC3_EHigh();
		else
			IIC3_ELow();
	}

	IIC3_EAck();	// ACK

////////////////// write reg. data. //////////////////
	for(i = 8; i>0; i--)
	{
		if((IicData >> (i-1)) & 0x0001)
			IIC3_EHigh();
		else
			IIC3_ELow();
	}

	IIC3_EAck();	// ACK

	IIC3_EEnd();
}

static void bq24160_print_Register(void)
{
    u8 read_data[8];
    u8 read_addr;
    static u32 count = 0;

    for(read_addr = 0; read_addr < 8; read_addr ++)
    {
        IIC1_ERead(BQ24160_ADDR, read_addr, &(read_data[read_addr]));
    }

    count ++;
    printf("[%d] BQ24160 reg[0~7] 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X 0x%02X\n",
        count, read_data[0], read_data[1], read_data[2], read_data[3], read_data[4], read_data[5], read_data[6], read_data[7]);
}

static void bq24160_print_State(u8 charge_state)
{
    switch(charge_state)
    {
    case BQ24160_REG0_STATE_NO_SOURCE:
        MANGO_ERROR("BQ24160_REG0_STATE_NO_SOURCE\n");
        break;
    case BQ24160_REG0_STATE_IN_READY:
        MANGO_DBG_BLUE("BQ24160_REG0_STATE_IN_READY\n");
        break;
    case BQ24160_REG0_STATE_USB_READY:
        MANGO_DBG_BLUE("BQ24160_REG0_STATE_USB_READY\n");
        break;
    case BQ24160_REG0_STATE_CHARGING_FROM_IN:
        MANGO_DBG_BLUE("BQ24160_REG0_STATE_CHARGING_FROM_IN\n");
        break;
    case BQ24160_REG0_STATE_CHARGING_FROM_USB:
        MANGO_DBG_BLUE("BQ24160_REG0_STATE_CHARGING_FROM_USB\n");
        break;
    case BQ24160_REG0_STATE_CHARGE_DONE:
        MANGO_DBG_BLUE("BQ24160_REG0_STATE_CHARGE_DONE\n");
        break;
    case BQ24160_REG0_STATE_NA:
        MANGO_DBG_BLUE("BQ24160_REG0_STATE_NA\n");
        break;
    case BQ24160_REG0_STATE_FAULT:
        MANGO_ERROR("BQ24160_REG0_STATE_FAULT\n");
        break;
    }
}

static int bq24160_power_key_pressed(void)
{
    return (GPX1DAT & 0x04);	// check GPX1_2 value
}

static void bq24160_power_key_config(void)
{
    u32 reg_val;

    // Power Key GPIO configurations
    printf("Power Key GPIO configurations....\n\n");
    //printf("GPX1CON = 0x%08X\n", (unsigned int)GPX1CON);
    reg_val = GPX1CON;
    reg_val &= 0xFFFFF0FF;  // set GPX1_2 as input
    GPX1CON = reg_val;
    printf("GPX1CON = 0x%08X\n", (unsigned int)GPX1CON);
    //reg_val = GPX1PUD;
    printf("GPX1PUD = 0x%04X\n", (unsigned int)GPX1PUD);
    reg_val = GPX1PUD;
    reg_val |= 0x0030;      // set GPX1_2 PullUP
    GPX1PUD = reg_val;
    printf("GPX1PUD = 0x%04X\n", (unsigned int)GPX1PUD);

    printf("GPX1_2 = %d\n\n", (unsigned int)(GPX1DAT & 0x04));
}

static void bq24160_green_led_config(void)
{
    u32 reg_val;

    // GREEN LED GPIO configurations
    printf("Green LED GPIO configurations....\n\n");
    reg_val = GPX2CON;
    reg_val &= 0xFFFFF0FF;  // set GPX2_2 as output
    reg_val |= 0x00000100;
    GPX2CON = reg_val;
    printf("GPX2CON = 0x%08X\n", (unsigned int)GPX2CON);
    printf("GPX2PUD = 0x%04X\n", (unsigned int)GPX2PUD);
    reg_val = GPX2PUD;
    reg_val &= 0xFFCF;      // set GPX2_2 Pull None
    GPX2PUD = reg_val;
    printf("GPX2PUD = 0x%04X\n", (unsigned int)GPX2PUD);

    printf("GPX2_2 = 0x%04X\n\n", (unsigned int)(GPX2DAT & 0x04));
}

static void bq24160_green_led(int onoff)
{
    u32 reg_val;

    // Green LED ON, XEINT18 : GPX2(2)
    reg_val = GPX2DAT;
    printf("GPX2DAT = 0x%04X\n", reg_val);

    if(BQ24160_LED_ON == onoff)
        GPX2DAT = reg_val | 0x04;
    else
        GPX2DAT = reg_val & 0xFB;

    printf("GPX2DAT = 0x%04X\n", (unsigned int)GPX2DAT);
}

static void bq24160_red_led_config(void)
{
    u32 reg_val;

    // RED LED GPIO configurations
    printf("RED LED GPIO configurations....\n\n");
    reg_val = GPX3CON;
    reg_val &= 0xFFFFFF0F;  // set GPX3_1 as ouput
    reg_val |= 0x00000010;  // set GPX3_1 as ouput
    GPX3CON = reg_val;
    printf("GPX3CON = 0x%08X\n", (unsigned int)GPX3CON);
    printf("GPX3PUD = 0x%04X\n", (unsigned int)GPX3PUD);
    reg_val = GPX3PUD;
    reg_val |= 0x000C;      // set GPX3_1 Pull None
    GPX3PUD = reg_val;
    printf("GPX3PUD = 0x%04X\n", (unsigned int)GPX3PUD);

    printf("GPX3_1 = 0x%04X\n\n", (unsigned int)(GPX3DAT & 0x02));
}

static void bq24160_red_led(int onoff)
{
    u32 reg_val;

    // Red LED ON
    reg_val = GPX3DAT;
    printf("GPX3DAT = 0x%04X\n", reg_val);

    if(BQ24160_LED_ON == onoff)
        GPX3DAT = reg_val | 0x02;
    else
        GPX3DAT = reg_val & 0xFD;

    printf("GPX3DAT = 0x%04X\n", (unsigned int)GPX3DAT);
}

static void bq24160_update_charge_led_state(charge_led_state cur_state)
{
	static charge_led_state state = BQ24160_LED_STATE_CHARGE_NONE;

	if ( cur_state == state )
		return;

	state = cur_state;
	if ( state == BQ24160_LED_STATE_CHARGE_NONE )
	{
		bq24160_red_led(BQ24160_LED_OFF);
		bq24160_green_led(BQ24160_LED_OFF);
	}
	else if ( state == BQ24160_LED_STATE_CHARGE_DONE )
	{
		bq24160_red_led(BQ24160_LED_OFF);
		bq24160_green_led(BQ24160_LED_ON);
	}
	else if ( state == BQ24160_LED_STATE_CHARGING )
	{
		bq24160_red_led(BQ24160_LED_ON);
		bq24160_green_led(BQ24160_LED_OFF);
	}
	else
		printf("BQ24160 Unknown CHARGE STATE!!!\n");
}

static void bq24160_Delay_1_Second(void)
{
    volatile u32 i;
    for(i = 0; i < 3225806; i++);
}

static void bq24160_Initialize(void)
{
    u8 data;

    MANGO_DBG_DEFAULT_BLUE;

    bq24160_green_led_config();
    bq24160_red_led_config();

    IIC1_ESetport();

#if 0
    MANGO_DBG_BLUE("Reset All registers\n");

    IIC1_ERead(BQ24160_ADDR, 0x2, &data);
    data |= 0x80;
    IIC1_EWrite(BQ24160_ADDR, 0x2, data); /* Reset All Registers */

    bq24160_Delay_1_Second();
#endif

    MANGO_DBG_BLUE("Before writing BQ24160 register values...\n\n");

    bq24160_print_Register();

    IIC1_EWrite(BQ24160_ADDR, 0x2, 0x5C); /* USB host/charger with 1500mA current limit */

    // ---------------------------------------------------------------------------
    //IIC1_EWrite(BQ24160_ADDR, 0x3, 0x8C); /* Configure V_BATREG: 4.2V */
    //IIC1_EWrite(BQ24160_ADDR, 0x3, 0x90); /* Configure V_BATREG: 4.22V */
    IIC1_EWrite(BQ24160_ADDR, 0x3, 0x94); /* Configure V_BATREG: 4.24V */
    //IIC1_EWrite(BQ24160_ADDR, 0x3, 0x98); /* Configure V_BATREG: 4.26V */
    //IIC1_EWrite(BQ24160_ADDR, 0x3, 0x9C); /* Configure V_BATREG: 4.28V */
    //IIC1_EWrite(BQ24160_ADDR, 0x3, 0xA0); /* Configure V_BATREG: 4.3V */
    // ---------------------------------------------------------------------------

    // ---------------------------------------------------------------------------
    //IIC1_EWrite(BQ24160_ADDR, 0x5, 0xD2); /* charge current is 2500mA, termination current is 150mA */
    //IIC1_EWrite(BQ24160_ADDR, 0x5, 0xD3); /* charge current is 2500mA, termination current is 200mA */
    IIC1_EWrite(BQ24160_ADDR, 0x5, 0xD4); /* charge current is 2500mA, termination current is 250mA */
    //IIC1_EWrite(BQ24160_ADDR, 0x5, 0xD5); /* charge current is 2500mA, termination current is 300mA */
    //IIC1_EWrite(BQ24160_ADDR, 0x5, 0xD7); /* charge current is 2500mA, termination current is 400mA */
    // ---------------------------------------------------------------------------

//    IIC1_EWrite(BQ24160_ADDR, 0x6, 0x40);	// Configure DPM

    // ---------------------------------------------------------------------------
    //IIC1_EWrite(BQ24160_ADDR, 0x7, 0x40); /* 9 hour fast charge */
    IIC1_EWrite(BQ24160_ADDR, 0x7, 0x60); /* Disable safety timers */
    // ---------------------------------------------------------------------------

    IIC1_ERead(BQ24160_ADDR, 0x0, &data);	// Clear Timer
    IIC1_EWrite(BQ24160_ADDR, 0x0, data | 0x80);

    MANGO_DBG_BLUE("After writing BQ24160 register values...\n\n");

    bq24160_print_Register();
}

static u8 bq24160_Kick_Watch_Dog(void)
{
    u8 data;

    // read chargind status
    // kick bq24160 watch dog
    IIC1_ERead(BQ24160_ADDR, 0, &data);
    IIC1_EWrite(BQ24160_ADDR, 0, data | 0x80);

    return data;
}

u8 g_old_charge_state = 0xFF;

static void bq24160_work(void)
{
    int k;
    u8 charge_state;
    u8 data;
    u16 data_u16;

    MANGO_DBG_DEFAULT_BLUE;

    bq24160_Initialize();

    MANGO_DBG_BLUE("Stops the booting process and Charing battery...\n");
    MANGO_DBG_BLUE("To continue the booting, Press the POWER Key.\n\n");

    while(!bq24160_power_key_pressed())
    {
        data = bq24160_Kick_Watch_Dog();
        charge_state = data & 0x70;

        bq24160_print_State(charge_state);
        bq24160_print_Register();

        switch(charge_state)
        {
        case BQ24160_REG0_STATE_NO_SOURCE:
        case BQ24160_REG0_STATE_IN_READY:
        case BQ24160_REG0_STATE_USB_READY:
        case BQ24160_REG0_STATE_NA:
        case BQ24160_REG0_STATE_FAULT:
            bq24160_update_charge_led_state(BQ24160_LED_STATE_CHARGE_NONE);
            bq24160_Initialize();
            break;
            break;
        case BQ24160_REG0_STATE_CHARGING_FROM_IN:
        case BQ24160_REG0_STATE_CHARGING_FROM_USB:
            bq24160_update_charge_led_state(BQ24160_LED_STATE_CHARGING);
            break;
        case BQ24160_REG0_STATE_CHARGE_DONE:
            bq24160_update_charge_led_state(BQ24160_LED_STATE_CHARGE_DONE);
            break;
        }

        bq24160_Delay_1_Second();
//        bq24160_Delay_1_Second();
//        bq24160_Delay_1_Second();
//        bq24160_Delay_1_Second();
//        bq24160_Delay_1_Second();
    }
}

void bq24160_Process(void)
{
    MANGO_DBG_DEFAULT_BLUE;

    bq24160_power_key_config();

    if(!bq24160_power_key_pressed())
    {
        bq24160_work();
    }

    MANGO_DBG_BLUE("POWER KEY detected ... Continuing booting process...\n");
}

